#include <stdio.h>
#include <stdlib.h>
#include <math.h>

struct comp {
	int x, y; /* coords */
	int men; /* was it mentioned in the aswer already? */
};

int main(int argc, char **argv) {
	FILE *fq, *fa; /* question and the answer being judged */

	fq = fopen(argv[1], "r");
	fa = fopen(argv[2], "r");
//	if (fq == NULL || fa == NULL) {
//		return -1;
//	}
	
	int N; /* number of computers */
	double length = 0; /* total length of current journey */
	int current; /* current computer */
	int first; /* first computer */
	int next; /* next computer */

	fscanf(fq, "%d", &N);

	struct comp *comps = (struct comp*)malloc(N*sizeof(struct comp)); /* there should be only one computer mentioned twice in the answer */
	for (int i=0; i<N; i++) {
		comps[i].men = 0; /* none of the computers was already mentioned */
		fscanf(fq, "%d %d", &comps[i].x, &comps[i].y);
	}
	
	if (fscanf(fa, "%d", &first) < 0) {
		fprintf(stderr, "Output ended at the very beginning\n");
		return 1;
	}
	first--;
	current = first;

	for (int i=0; i<N; i++) {
		if (fscanf(fa, "%d", &next) <= 0) {
			fprintf(stderr, "Output ended before closing the journey\n");
			return 1;
		}
		next--;
		comps[next].men++;
		length += sqrt((double)(((double)comps[current].x-(double)comps[next].x)*((double)comps[current].x-(double)comps[next].x) +
					((double)comps[current].y-(double)comps[next].y)*((double)comps[current].y-(double)comps[next].y)));
		if ((comps[next].men > 1) && (i != N-1)) {
			fprintf(stderr, "Computer number %d was mentioned twice or more in the sequence\n", next+1);
			return 1;
		}
		current = next;
	}
	if (current != first) {
		fprintf(stderr, "The first and the last computer in the sequence don't match\n");
		return 1;
	}

	fprintf(stderr, "OK[%.3f]\n", length);
	return 0;
}
